/*
 * ID.java
 *
 * Created on October 19, 2004, 12:38 AM
 */

package university;


/**
 * Singleton class to create IDs.
 * @author Nathan Balon
 * University Application
 * CIS 550 - Object Oriented Programming
 * U 0f M Dearborn
 * November 7, 2004
 * @version 1.0
 */
public class ID implements java.io.Serializable{
    
    /** Creates a new instance of ID */
    private ID() {
            idNumber = 1;
    }
    
    /** Returns an instance of the ID class 
      * @return An instance of ID
      */
    public synchronized static ID getFactory(){
        if(id == null){
            id = new ID();
        }
        return id;
    }
    
    /** Returns the next id. 
      * @return Returns the the next id
      */
    public synchronized int getNextId(){
        return idNumber++;
    }
    
    /** Set the value of the next id number 
     *  @param count the next id number to use
     */
    public synchronized void setId(int count){
         idNumber = count;

    }
       
    private static ID id;
    private static int idNumber;

}
