/*
 * Staff.java
 *
 * Created on October 11, 2004, 1:42 AM
 */

package university;

/**
 * Class for the staff of the university
 * @author  Nathan Balon
 * University Application
 * CIS 550 - Object Oriented Programming
 * U 0f M Dearborn
 * November 7, 2004
 * @version 1.0
 */
public class Staff extends Employee implements Cloneable{

    
    /**
     * Creates a new instance of Staff.
     * @param name The name of the staff member.
     * @param gender The geneder of the staff member.
     * @param address The address of the staff member.
     * @param salary The staffs salary.
     * @param status Theather the staff member if part time of full time.
     * @param jobTitle The staff members job title. 
     */
    public Staff(String name, Sex gender, Address address, Unit unit, 
                 int salary, StaffStatus status, String jobTitle){
        super(name, gender, address, unit, salary);
        this.status = status;
        this.jobTitle = jobTitle;
    }
    
    /**
     * Clone a new object
     * @throws java.lang.CloneNotSupportedException Throws CloneNotSupportedException
     * @return Object a cloned object
     */    
    @Override
    public Object clone() throws java.lang.CloneNotSupportedException{
        Staff cloned = (Staff)super.clone();
        cloned.jobTitle = new String(jobTitle);
        cloned.status = status;
        return cloned;
    }    
    
    /**
     * Returns the staffs job title.
     * @return String representing the staffs job title.
     */
    public final String getJobTitle(){
        return jobTitle;
    }
    
    /**
     * Sets the staffs job title.
     * @param jobTitle the job title of the staff.
     */
    public final void setJobTitle(String jobTitle){
        this.jobTitle = jobTitle;
    }
    
    /**
     * Returns a String representation of the staff member.
     * @return String representing the staff.
     */
    @Override
    public String toString(){
        return(super.toString() + ", Job: " + jobTitle + ", Work status: " +
               status.toString().toLowerCase() + "\n");
    }
 
    private String jobTitle;        // the staff members job title
    private StaffStatus status;     // parttime of fulltime
}
